package com.steerinfo.meterwork.meterworkprewgttype.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcarrecover.model.MeterWorkCarRecover;
import com.steerinfo.meterwork.meterworkprewgttype.mapper.MeterWorkPreWgttypeMapper;
import com.steerinfo.meterwork.meterworkprewgttype.model.MeterWorkPreWgttype;
import com.steerinfo.meterwork.meterworkprewgttype.service.IMeterWorkPreWgttypeService;
import com.steerinfo.pretrack.pretrackscale.mapper.PreTrackScaleMapper;
import com.steerinfo.pretrack.pretrackscale.model.PreTrackScale;
import com.steerinfo.pretrack.pretrackscale.service.IPreTrackScaleService;
import com.steerinfo.pretrack.pretrackscale.service.impl.PreTrackScaleServiceImpl;
import com.steerinfo.util.FieldsCollector;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterWorkPreWgttype RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-12 10:49
 * 类描述
 * 修订历史：
 * 日期：2022-01-12
 * 作者：generator
 * 参考：
 * 描述：MeterWorkPreWgttype RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkprewgttypes")
@Api(value = "/${api.version}/meterworkprewgttypes", tags = "计量重量类型预处理 - MeterWorkPreWgttypeController")
public class MeterWorkPreWgttypeController extends BaseRESTfulController {

    @Autowired
    IMeterWorkPreWgttypeService meterWorkPreWgttypeService;

    @Autowired
    IPreTrackScaleService preTrackScaleService;

    @Resource
    MeterWorkPreWgttypeMapper meterWorkPreWgttypeMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkprewgttype:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkPreWgttype> list = meterWorkPreWgttypeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkprewgttype:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkPreWgttype> list = meterWorkPreWgttypeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkPreWgttype对象创建")
    @Transactional(rollbackFor = Exception.class)
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody HashMap model){
        RESTfulResult rm = failed();
        try {
            MeterWorkPreWgttype meterWorkPreWgttype = new MeterWorkPreWgttype();
            meterWorkPreWgttype.setWeightTypeNo(model.get("weightTypeNo") == null?"":model.get("weightTypeNo").toString());
            meterWorkPreWgttype.setWeightTypeName(model.get("weightTypeName") == null?"":model.get("weightTypeName").toString());
            meterWorkPreWgttype.setCarNo(model.get("carNo") == null?"":model.get("carNo").toString());
            meterWorkPreWgttype.setCreateManName(model.get("createManName") == null?"":model.get("createManName").toString());
            meterWorkPreWgttype.setCreateManPhone(model.get("createManPhone") == null?"":model.get("createManPhone").toString());
            String preTrackScaleNo = model.get("preTrackScaleNo") == null?"":model.get("preTrackScaleNo").toString();
            rm = meterWorkPreWgttypeService.addOrAbolish(meterWorkPreWgttype);
            if (preTrackScaleNo == "" || preTrackScaleNo.equals("")){
                return rm;
            }else{
                PreTrackScale preTrackScale = new PreTrackScale();
                preTrackScale.setPredictionNo(preTrackScaleNo);
                preTrackScale.setCarNo(meterWorkPreWgttype.getCarNo());
                int scale = preTrackScaleService.setPreIndex(preTrackScale);
                if(scale < 1){
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    rm.setMessage("已经存在已使用的委托，不可修改");
                }
                return rm;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            rm.setMessage("操作异常,请确认!!");
            return rm;
        }
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkprewgttype:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkPreWgttype meterWorkPreWgttype = meterWorkPreWgttypeService.getById(id);
        return success(meterWorkPreWgttype);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkPreWgttype信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkPreWgttype", value = "详细实体meterWorkPreWgttype", required = true, dataType = "MeterWorkPreWgttype")
    })
    //@RequiresPermissions("meterworkprewgttype:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkPreWgttype model){
        model.setId(id);
        MeterWorkPreWgttype meterWorkPreWgttype = meterWorkPreWgttypeService.modify(model);
        return success(meterWorkPreWgttype);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkprewgttype:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkPreWgttypeService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据车号获取当前预约毛皮信息", notes="根据车号获取当前预约毛皮信息")
    @PostMapping(value = "/getCarPreInfo")
    public RESTfulResult getCarPreInfo(@RequestBody HashMap params){
        RESTfulResult rm = failed();
        try {
            String carNo = params.get("carNo") == null?"":params.get("carNo").toString();
            rm = meterWorkPreWgttypeService.getCarPreInfo(carNo);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return rm;
    }

    @ApiOperation(value="根据车号取消皮重预约或者毛重委托", notes="根据车号取消皮重预约或者毛重委托")
    @Transactional(rollbackFor = Exception.class)
    @PostMapping(value = "/abolishPreWgtType")
    public RESTfulResult abolishPreWgtType(@RequestBody HashMap params){
        RESTfulResult rm = failed();
        try {
            String carNo = params.get("carNo") == null?"":params.get("carNo").toString();
            rm = meterWorkPreWgttypeService.abolishPreWgtType(carNo);
        } catch (Exception ex) {
            ex.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            rm.setMessage("操作异常，" + ex.getMessage());
        }
        return rm;
    }


    @ApiOperation(value="不分页查询", notes="不分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkprewgttype:view")
    @PostMapping(value = "/selectNoPage")
    public RESTfulResult selectNoPage(@RequestBody MeterWorkPreWgttype parmas){

        RESTfulResult rm = failed();
        Map<String, Object> map = FieldsCollector.beanToMap(parmas);

        try {
            List<MeterWorkPreWgttype> rows = meterWorkPreWgttypeMapper.selectByParameters(map);
            rm.setCode("200");
            rm.setMessage("操作成功");
            rm.setSucceed();
            rm.setData(rows);
            return rm;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {
        }
        return rm;
    }

    @ApiOperation(value="试验性称量确认", notes="试验性称量确认")
    @PostMapping(value = "/submitFlag")
    public RESTfulResult submitFlag(@RequestBody HashMap params){
        RESTfulResult rm = failed();
        try {
            String carNo = params.get("carNo") == null?"":params.get("carNo").toString();
            int i  = meterWorkPreWgttypeMapper.updateSubmitFlag(carNo);
            /*if(i < 1) {
                rm.setMessage("预约信息已确认！！");
                return rm;
            }*/
            rm.setSucceed();
            rm.setCode("200");
            rm.setMessage("操作成功");
            rm.setData(null);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return rm;
    }
}
